export function getmonthnumber(date) {
    let month = date.slice(5, 7);
    return month;
}
export function getmonthname(month, year) {
    if (month && year) {
        let monthinno = parseInt(month.toString());
        //before:  let monthinno = parseInt(month);
        let yearinno = parseInt(year.toString());
        let monthname = new Date(yearinno, monthinno - 1).toLocaleString('default', { month: 'long' });
        return monthname;
    }
    else {
        return;
    }
}
export function daysinmonth2(month, year) {
    let monthinno = parseInt(month);
    let yearinno = parseInt(year);
    let daysinmonth1 = new Date(yearinno, monthinno, 0).getDate();
    return daysinmonth1;
}
export function getdayofweek(date) {
    let day = date.slice(8, 10);
    let month = date.slice(5, 7);
    let year = date.slice(0, 4);
    let dayinno = parseInt(day);
    let monthinno = parseInt(month);
    let yearinno = parseInt(year);
    let dayofweek = new Date(yearinno, monthinno - 1, dayinno).getDay();
    return dayofweek;
}
export function getdayname(dayofweek) {
    let days = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
    let dayname = days[dayofweek];
    return dayname;
}
export function getWeeksInMonth(month, year) {
    // Create a date object for the first and last day of the month
    let monthinno = parseInt(month);
    let yearinno = parseInt(year);
    let firstDay = new Date(yearinno, monthinno - 1, 1);
    let lastDay = new Date(yearinno, monthinno, 0);
    // Function to calculate the week number of a date
    function getWeekNumber(d) {
        d = new Date(Date.UTC(d.getFullYear(), d.getMonth(), d.getDate()));
        d.setUTCDate(d.getUTCDate() + 4 - (d.getUTCDay() || 7));
        let yearStart = new Date(Date.UTC(d.getUTCFullYear(), 0, 1));
        //  before  let weekNo = Math.ceil((((d - yearStart) / 86400000) + 1) / 7);
        let weekNo = Math.ceil((((d.getTime() - yearStart.getTime()) / 86400000) + 1) / 7);
        return weekNo;
    }
    // Get the week number for the first and last day of the month
    let firstWeek = getWeekNumber(firstDay);
    let lastWeek = getWeekNumber(lastDay);
    // Return an array of the weeks
    let weeks = [];
    let weekobject = {
        weeknumber: 0,
        year: 0
    };
    let lastweektoloop;
    //WAIT I WAS THINKING ABOUT FOR GOING BACK, DUNNO FI TAHT WILL AFFECT GOING FORWARD LOGIC
    if (lastWeek < firstWeek) {
        let lastpossibleweek = 52;
        let difference = lastpossibleweek - firstWeek; //e.g. 4
        //push first week first
        let firstweekobject = {
            weeknumber: firstWeek,
            year: yearinno
        };
        weeks.push(firstweekobject);
        for (let i = 1; i <= difference; i++) {
            weekobject = {
                weeknumber: firstWeek + i,
                year: yearinno
            };
            weeks.push(weekobject);
        }
        //and for the weeks in the new year
        for (let i = 1; i <= lastWeek; i++) {
            weekobject = {
                weeknumber: i,
                year: yearinno + 1
            };
            weeks.push(weekobject);
        }
        let beforelastweek = 52; //last week to loop - for the loop - last week of year
        lastweektoloop = beforelastweek;
    }
    else {
        lastweektoloop = lastWeek;
        if (lastWeek)
            for (let i = firstWeek; i <= lastweektoloop; i++) {
                let i2 = i; // / .toString()
                if (i < 10) {
                    i2 = 0 + i;
                }
                weekobject = {
                    weeknumber: i2,
                    year: yearinno
                };
                //  weeks.push(i2);
                weeks.push(weekobject);
                if (lastWeek < firstWeek) {
                    const indexOfWeek1 = weeks.findIndex(element => element.weeknumber === 1);
                    // If found, move this element to the end of the array
                    if (indexOfWeek1 !== -1) {
                        const [week1] = weeks.splice(indexOfWeek1, 1);
                        weeks.push(week1);
                    }
                }
            }
    }
    return weeks;
}
export function makearrayofdatesfromWeek(weeknumber, year, monthnumber, monthname) {
    let yearinno = parseInt(year);
    let weeknumber1 = parseInt(weeknumber);
    let monthinno = parseInt(monthnumber);
    let weekdays = [];
    //get first day of weeknumber
    //  let firstdayofweek = new Date(year, 0, 1 + (weeknumber1 - 1) * 7);
    // Example Usage:
    const firstdayofweek = getDateFromWeekNumber(yearinno, weeknumber1);
    //for loop
    for (let i = 1; i < 8; i++) {
        let currentday1 = new Date(firstdayofweek);
        //add days to firstdayofweek
        let currentday = currentday1.setDate(firstdayofweek.getDate() + i);
        let currentdayclean = new Date(currentday);
        //to yyyy-mm-dd
        let cleanyes = currentdayclean.toISOString().slice(0, 10);
        let monthclean = cleanyes.slice(5, 7);
        let yearclean = cleanyes.slice(0, 4);
        let dateobj = {
            datetxt: cleanyes,
            dateobj: currentdayclean,
            monthname: getmonthname(parseInt(monthclean), parseInt(yearclean)),
            //before:       monthname: getmonthname(monthclean, yearclean),
            monthnumber: getmonthnumber(cleanyes)
        };
        weekdays.push(dateobj);
    }
    return weekdays;
}
//HERE U GIVE YEAR, WEEK NUMBER AND RETURNS 'date object' - works'
function getDateFromWeekNumber(year, weekNumber) {
    // Create a new date object representing January 1st of the given year
    const januaryFirst = new Date(year, 0, 1);
    // Calculate the number of days to add to January 1st
    // Get the day of the week for January 1st (0-6, where 0 is Sunday and 6 is Saturday)
    let dayOfWeek = januaryFirst.getDay();
    // Adjust to make Monday the first day of the week
    dayOfWeek = dayOfWeek === 0 ? 7 : dayOfWeek;
    // Calculate the offset to the first Monday of the year
    const firstMondayOfYear = dayOfWeek > 4 ? 8 - dayOfWeek : 1 - dayOfWeek;
    // Calculate the number of days from the first Monday to the specified week
    // Subtract 1 from weekNumber because we start counting weeks from 1
    const daysToAdd = (weekNumber - 1) * 7 + firstMondayOfYear;
    // Add the calculated number of days to January 1st
    januaryFirst.setDate(januaryFirst.getDate() + daysToAdd);
    return januaryFirst;
}
export function convertYMD2DMY(date) {
    if (date) {
        let datearray = date.split('-');
        let year = datearray[0];
        let month = datearray[1];
        let day = datearray[2];
        let newdate = `${day}-${month}-${year}`;
        return newdate;
    }
    else {
        return '';
    }
}
export function convertDMY2YMD(date) {
    if (date) {
        let datearray = date.split('-');
        let day = datearray[0];
        let month = datearray[1];
        let year = datearray[2];
        let newdate = `${year}-${month}-${day}`;
        return newdate;
    }
    else {
        return '';
    }
}
export function convertMDY2YMD(date) {
    if (date) {
        let datearray = date.split('-');
        let month = datearray[0];
        let day = datearray[1];
        let year = datearray[2];
        let newdate = `${year}-${month}-${day}`;
        return newdate;
    }
    else {
        return '';
    }
}
export function convertDMY2YMDarray(datearray) {
    if (datearray.length > 0) {
        let count = datearray.length;
        let newdatearray = [];
        for (let i = 0; i < count; i++) {
            let date = datearray[i];
            let converted = convertDMY2YMD(date);
            newdatearray.push(converted);
        }
        return newdatearray;
    }
    else {
        return []; // Return an empty array instead of an empty string
    }
}
export function convertMDY2YMDarray(datearray) {
    if (datearray.length > 0) {
        let count = datearray.length;
        let newdatearray = [];
        for (let i = 0; i < count; i++) {
            let date = datearray[i];
            let converted = convertMDY2YMD(date);
            newdatearray.push(converted);
        }
        return newdatearray;
    }
    else {
        return []; // Return an empty array instead of an empty string
    }
}
export function convertFormat(format, date) {
    if (date) {
        if (format === 'DDMMYYYY') {
            return convertDMY2YMD(date);
        }
        else if (format === 'YYYYMMDD') {
            return (date);
        }
        else if (format === 'MMDDYYYY') {
            return convertMDY2YMD(date);
        }
    }
}
